﻿using System;

namespace dynamic
{
    public class dynamicClass
    {
        public int AddOne(int originalValue)
        {
            return originalValue + 1;
        }

        public int TripleIt(int originalValue)
        {
            return originalValue * 3;
        }
    }

    class Program
    {
        public static void showSimpleExample()
        {
            Console.Write("Enter a value to add 1 to: ");
            int addOneToIt = Convert.ToInt32(Console.ReadLine());
            Console.WriteLine("");

            //Compiler determines the type (in this case it is of type dynamicClass)...at compile time
            var dynamicVar = new dynamicClass();

            Console.WriteLine("{0} + 1 = {1}", addOneToIt, dynamicVar.AddOne(addOneToIt));
            Console.WriteLine("");

            Console.Write("Enter a value to triple: ");
            int tripleIt = Convert.ToInt32(Console.ReadLine());
            Console.WriteLine("");

            dynamic dynamicDynamic = new dynamicClass();

            try
            {
                //The CanAddAnythingHere() does not exist, but the program will compile.
                dynamicDynamic.CanAddAnythingHere();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                Console.WriteLine("");
                Console.WriteLine("Using a try/catch we can continue using the correct method, the answer is: ");
                Console.WriteLine("");
            }

            Console.WriteLine("{0} x 3 = {1}", tripleIt, dynamicDynamic.TripleIt(tripleIt));
            Console.ReadLine();
        }

        static void Main(string[] args)
        {
            showSimpleExample();

            double sx = 11.34F;
            int ix = 1;
            double vy = sx + ix;
            Console.Write(vy);
            Console.ReadLine();

            double x = 11.34F;
            int y = 1;
            var z = x + y;
            Console.Write(z);
            Console.ReadLine();
        }
    }
}
